DT_TOP = 0x00000000;
DT_LEFT = 0x00000000;
DT_CENTER = 0x00000001;
DT_RIGHT = 0x00000002;
DT_VCENTER = 0x00000004;
DT_BOTTOM = 0x00000008;
DT_WORDBREAK = 0x00000010;
DT_CALCRECT = 0x00000400;
DT_NOPREFIX = 0x00000800;
DT_END_ELLIPSIS = 0x00008000;

MF_SEPARATOR = 0x00000800;
MF_ENABLED = 0x00000000;
MF_GRAYED = 0x00000001;
MF_DISABLED = 0x00000002;
MF_UNCHECKED = 0x00000000;
MF_CHECKED = 0x00000008;
MF_STRING = 0x00000000;
MF_POPUP = 0x00000010;

IDC_ARROW = 32512;
IDC_IBEAM = 32513;
IDC_WAIT = 32514;
IDC_CROSS = 32515;
IDC_UPARROW = 32516;
IDC_SIZE = 32640;
IDC_ICON = 32641;
IDC_SIZENWSE = 32642;
IDC_SIZENESW = 32643;
IDC_SIZEWE = 32644;
IDC_SIZENS = 32645;
IDC_SIZEALL = 32646;
IDC_NO = 32648;
IDC_APPSTARTING = 32650;
IDC_HAND = 32649;

ColorTypeCUI = {
	text: 0,
	selection_text: 1,
	inactive_selection_text: 2,
	background: 3,
	selection_background: 4,
	inactive_selection_background: 5,
	active_item_frame: 6
};

FontTypeCUI = {
	items: 0,
	labels: 1
};

ColorTypeDUI = {
	text: 0,
	background: 1,
	highlight: 2,
	selection: 3
};

FontTypeDUI = {
	defaults: 0,
	tabs: 1,
	lists: 2,
	playlists: 3,
	statusbar: 4,
	console: 5
};

function RGB(r,g,b) {
	return (0xff000000|(r<<16)|(g<<8)|(b)); 
}

function get_font() {
	if(dui) {
		g_font = window.GetFontDUI(FontTypeDUI.defaults);
	} else {
		g_font = window.GetFontCUI(FontTypeCUI.items);
	}
}

function get_colors() {
	if (dui) {
		g_textcolor = window.GetColorDUI(ColorTypeDUI.text);
		g_textcolor_hl = window.GetColorDUI(ColorTypeDUI.highlight);
		g_backcolor = window.GetColorDUI(ColorTypeDUI.background);
	} else {
		g_textcolor = window.GetColorCUI(ColorTypeCUI.text);
		g_textcolor_hl = window.GetColorCUI(ColorTypeCUI.text);
		g_backcolor = window.GetColorCUI(ColorTypeCUI.background);
	}
}

function on_playlist_switch() {
	on_item_focus_change();
}

function on_colors_changed() {
	get_colors();
	window.Repaint();
}

function on_font_changed() {
	get_font();
	window.Repaint();
}

function on_item_focus_change() {
	if (g_metadb) window.UnwatchMetadb();
	g_metadb = fb.IsPlaying ? fb.GetNowPlaying() : fb.GetFocusItem();
	if (g_metadb) {
		try { on_metadb_changed(); } catch(e) {}
		window.WatchMetadb(g_metadb);
	}
}

function text_input_box(title, message, filename) {
	WshShell.Run("\"" + wsf + "\" \"" + title + "\" \"" + message + "\" \"" + filename + "\"", 0, true);
	return read(filename);
}

function read(fn) {
	try {
		var f = fso.OpenTextFile(fn, 1, false, -1);
		var s = f.Readline();
		f.Close()
		return s;
	} catch(e) {
		return '';
	}
}

function addCommas(nStr) {
	nStr += '';
	x = nStr.split('.');
	x1 = x[0];
	x2 = x.length > 1 ? '.' + x[1] : '';
	var rgx = /(\d+)(\d{3})/;
	while (rgx.test(x1)) {
		x1 = x1.replace(rgx, '$1' + ',' + '$2');
	}
	return x1 + x2;
}

function lastfm(qs, user_agent, func) {
	xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
	xmlhttp.open("GET", "http://ws.audioscrobbler.com/2.0?&api_key=" + api_key +  "&username=" + username + qs + "&s=" + Math.random(), true);
	xmlhttp.setRequestHeader('User-Agent',user_agent);
	xmlhttp.send();
	xmlhttp.onreadystatechange = function() {
		if (xmlhttp.readyState == 4) {
			if (xmlhttp.status == 200) {
				func();
			} else {
				fb.trace(xmlhttp.responsetext);
			}
		}
	}
}

function decodeXML(value) {
	value = value.replace(/<\/?[^>]+(>|$)/g, "");
	doc = new ActiveXObject("htmlfile");
	doc.open();
	div = doc.createElement("div");
	div.innerHTML = value.replace(/\n/g, "<br>");
	value = div.innerHTML;
	value = value.replace(/<BR>/g,"\n");
	value = value.replace(/&nbsp;/g," ");
	return value.replace(/&amp;/g,"&");
}

String.prototype.count=function(s1) { 
	return (this.length - this.replace(new RegExp(s1,"g"), '').length) / s1.length;
}

var g_metadb = fb.GetFocusItem();
var dui = window.InstanceType;
var WshShell = new ActiveXObject("WScript.Shell");
var fso = new ActiveXObject("Scripting.FileSystemObject");
var script_path = fb.FoobarPath + "skin\\mono_lite\\scripts\\";
var wsf = script_path + "input.wsf";
var images_path = fb.FoobarPath + "skin\\mono_lite\\lastfm\\";
var settings_path = fb.ProfilePath + "skin\\mono_lite_lastfm\\settings\\";
if(!fso.FolderExists(settings_path)) fso.CreateFolder(settings_path);
var data_folder = fb.ProfilePath + "skin\\mono_lite_lastfm\\data\\";
if(!fso.FolderExists(data_folder)) fso.CreateFolder(data_folder);
get_font();
get_colors();